unit Fmassoc;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, IniFiles;

type
  TFmPfAssoc = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    GroupBox1: TGroupBox;
    ListBox1: TListBox;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Button5: TButton;
    Button7: TButton;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    FTIniFile: TIniFile;
  public
    { Public declarations }
  end;

var
  FmPfAssoc: TFmPfAssoc;

implementation

{$R *.DFM}

procedure TFmPfAssoc.FormCreate(Sender: TObject);
begin
 Left:=(Owner as TForm).Left+((Owner as TForm).Width-Width) div 2;
 Top:=(Owner as TForm).Top+((Owner as TForm).Height-Height) div 2;
 FTIniFile := TIniFile.Create('FTWIN2.INI');
end;

procedure TFmPfAssoc.FormShow(Sender: TObject);
begin
 ListBox1.Items.Clear;
 FTIniFile.ReadSectionvalues ('EXT', ListBox1.Items);
 Edit1.Enabled:=false;
 Edit2.Enabled:=false;
 ListBox1.Enabled:=true;
 Button1.Visible:=true;
 Button2.Visible:=true;
 Button3.Visible:=true;
 Button4.Visible:=true;
 Button5.Visible:=false;
 Button7.Visible:=false;
 if ListBox1.Items.Count>0 then ListBox1.ItemIndex:=0;
 ListBox1Click(Sender);
end;

procedure TFmPfAssoc.Button4Click(Sender: TObject);
begin
 Close;
end;

procedure TFmPfAssoc.FormDestroy(Sender: TObject);
begin
 FTIniFile.Free;
end;

procedure TFmPfAssoc.Button1Click(Sender: TObject);
begin
 {add}
 Edit1.Text:='';
 Edit2.Text:='';
 Edit1.Enabled:=true;
 Edit2.Enabled:=true;
 ListBox1.Enabled:=false;
 Button1.Visible:=false;
 Button2.Visible:=false;
 Button3.Visible:=false;
 Button4.Visible:=false;
 Button5.Visible:=true;
 Button7.Visible:=true;
 Edit1.SetFocus;
end;

procedure TFmPfAssoc.Button5Click(Sender: TObject);
begin
 {ok pri new nebo edit}
 if (Edit1.Text<>'') and (Edit2.Text<>'') then
  FTIniFile.WriteString('EXT', LowerCase(Edit1.Text), Edit2.Text);
 FormShow(Sender);
end;

procedure TFmPfAssoc.Button7Click(Sender: TObject);
begin
 {cancel edit nebo new}
 Edit1.Text:='';
 Edit2.Text:='';
 Edit1.Enabled:=false;
 Edit2.Enabled:=false;
 ListBox1.Enabled:=true;
 Button1.Visible:=true;
 Button2.Visible:=true;
 Button3.Visible:=true;
 Button4.Visible:=true;
 Button5.Visible:=false;
 Button7.Visible:=false;
 if ListBox1.Items.Count>0 then ListBox1.ItemIndex:=0;
 ListBox1Click(Sender);
 end;

procedure TFmPfAssoc.Button3Click(Sender: TObject);
var i:integer;
begin
{delete}
 if ListBox1.ItemIndex>-1 then
  if Application.MessageBox('Delete item?','Atari Portfolio Manager',mb_okcancel+mb_iconquestion)=id_ok then
   begin
    ListBox1.Items.Delete(ListBox1.ItemIndex);
    FTIniFile.EraseSection('EXT');
    with ListBox1 do
     for i:=0 to Items.Count-1 do
      FTIniFile.WriteString('EXT',
                            Copy(Items.Strings[i],1,Pos('=',Items.Strings[i])-1),
                            Copy(Items.Strings[i],Pos('=',Items.Strings[i])+1,255));
    FormShow(Sender);
   end;
end;

procedure TFmPfAssoc.Button2Click(Sender: TObject);
begin
{edit}
 if ListBox1.ItemIndex>-1 then
  begin
   Edit1.Enabled:=false;
   Edit2.Enabled:=true;
   ListBox1.Enabled:=false;
   Button1.Visible:=false;
   Button2.Visible:=false;
   Button3.Visible:=false;
   Button4.Visible:=false;
   Button5.Visible:=true;
   Button7.Visible:=true;
   Edit2.SetFocus;
  end;
end;

procedure TFmPfAssoc.ListBox1Click(Sender: TObject);
begin
  {edit update}
  with ListBox1 do
  if ItemIndex>-1 then
   begin
    Edit1.Text:=Copy(Items.Strings[ItemIndex],1,Pos('=',Items.Strings[ItemIndex])-1);
    Edit2.Text:=Copy(Items.Strings[ItemIndex],Pos('=',Items.Strings[ItemIndex])+1,255);
   end
  else
   begin
    Edit1.Text:='';
    Edit2.Text:='';
   end;
end;

procedure TFmPfAssoc.ListBox1KeyPress(Sender: TObject; var Key: Char);
begin
 ListBox1Click(Sender);
end;

end.
