{last modified 27.11.2013}
{bug list}
{
 popsany v main
}
{to do
 setattr
}
unit Fmbatch;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Gauges, ExtCtrls, FObj, PFDrives,
  Fmcmfrm, Pf;

type
  TBatchType=(btCopy, btMove, btDelete, btSetAttr);
  TFmBatchProcess = class(TForm)
    Bevel1: TBevel;
    Gauge1: TGauge;
    Label1: TLabel;
    CancelButton: TBitBtn;
    Gauge2: TGauge;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure CancelButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    Canceled: boolean;
    ConfirmR: boolean;
    ConfirmHS: boolean;
    ConfirmRewrite: boolean;
  public
    { Public declarations }
    FilesCount,
    FileCount: integer;
    BytesCount,
    ByteCount: longint;
    Bytes1Count,
    Byte1Count: longint;
    procedure SetupWindow(Act:byte);
    function CopyFile(Source: TFileRec; SourcePath, DestPath: string): integer;
    function MoveFile(Source: TFileRec; SourcePath, DestPath: string): integer;
    function DeleteFile(Source: TFileRec; SourcePath: string): integer;
    function MakeDir(Source: TFileRec; SourcePath: string): integer;
    function RemoveDir(Source: TFileRec; SourcePath: string): integer;
    function SetAttribFile(Source: TFileRec; SourcePath: string;
                            AttrSet,AttrClear:byte; Time: longint): integer;
  end;

var
  FmBatchProcess: TFmBatchProcess;

implementation

function MyIntToStr(x: word):string;
 var pstr:string;
 begin
  pstr:=IntToStr(x);
  if (Length(pstr)<2) and (x>0) then pstr:='0'+pstr;
  Result:=pstr;
 end;

function FmtTime(T: TDateTime):string;
 var Hour, Min, Sec, MSec: Word;
     pstr: string;
 begin
  DecodeTime(T, Hour, Min, Sec, MSec);
  pstr:=MyIntToStr(Sec)+'s';
  if Min>0 then
   pstr:=MyIntToStr(Min)+'m '+pstr;
  if Hour>0 then
   pstr:=IntToStr(Hour)+'h '+pstr;
  Result:=pstr;
 end;

{$R *.DFM}
procedure TFmBatchProcess.SetupWindow(Act:byte);
 begin
  case Act of
   acCopy:
    begin
     Label1.Caption:='Copy';
     Label2.Caption:='From:';
     Label3.Caption:='To:';
    end;
   acMove:
    begin
     Label1.Caption:='Move';
     Label2.Caption:='From:';
     Label3.Caption:='To:';
    end;
   acDelete:
    begin
     Label1.Caption:='Delete';
     Label2.Caption:='File:';
     Label3.Visible:=false;
     Gauge1.Top:=56;
     Gauge2.Visible:=false;
     Label4.Top:=84;
     Label5.Visible:=false;
     Bevel1.Height:=81+20;
     CancelButton.Top:=96+20;
     Height:=163+20;
    end;
   acSetAttr:
    begin
     Label1.Caption:='Change attributes';
     Label2.Caption:='File:';
     Label3.Visible:=false;
     Gauge1.Top:=56;
     Gauge2.Visible:=false;
     Label4.Top:=84;
     Label5.Visible:=false;
     Bevel1.Height:=81+20;
     CancelButton.Top:=96+20;
     Height:=163+20;
    end;
  end;
  Label4.Caption:='';
  Label5.Caption:='';
  Gauge1.Progress:=0;
  Gauge2.Progress:=0;
  FileCount:=0;
  ByteCount:=0;
  ConfirmR:=false;
  ConfirmHS:=false;
  ConfirmRewrite:=false;
 end;


function TFmBatchProcess.CopyFile(Source: TFileRec; SourcePath, DestPath: string):integer;
const cPfCopyBufSize=1024;
      cPcCopyBufSize=1024*8;
var
  FromF, ToF: TPFFile;
  NumRead, NumWritten: Word;
  Buf: Pointer;
  CopyBufSize: word;
  PfPf:boolean;
  Skip, Cancel, Success: boolean;
  DosError: integer;
  SearchRec: TSearchRec;
  MyReal: real;
  PfPath: string;
begin
  PfPf:=(Drives[UpCase(SourcePath[1])].DriveType=dtPortfolio) and
        (Drives[UpCase(DestPath[1])].DriveType=dtPortfolio);
  if (Drives[UpCase(SourcePath[1])].DriveType=dtPortfolio) or
     (Drives[UpCase(DestPath[1])].DriveType=dtPortfolio) then
   CopyBufSize:=cPfCopyBufSize
  else
   CopyBufSize:=cPcCopyBufSize;
  Label2.Caption:='From:'+SourcePath+Source.GetName;
  Label3.Caption:='To:'+DestPath+Source.GetName;
  inc(FileCount);
  Byte1Count:=0;
  Bytes1Count:=Source.Size;
  Gauge1.Progress:=0;
  Label4.Caption:=IntToStr(FileCount)+'/'+IntToStr(FilesCount);
  Label5.Caption:=IntToStr(ByteCount div 1024)+'/'+IntToStr(BytesCount div 1024)+' kB';
  Refresh;
  Skip:=false;
  Cancel:=false;
  FillChar(SearchRec,SizeOf(SearchRec),0);
  {open fromf}
  Success:=false;
  if not PfPf then
   while not (Skip or Cancel or Success) do
    try
     FOpen(FromF,SourcePath+Source.GetName,fmRead);
     Success:=true;
    except
     FmConfirm:= TFmConfirm.Create(Self);
     case FmConfirm.Ask1('File: '+SourcePath+Source.GetName,'is ACCESS DENIED','Retry?') of
      mrCancel: Cancel:=true;
      mrNo:     Skip:=true;
     end;
     FmConfirm.Free;
    end;
  {open tof}
  if not (Skip or Cancel) then
   begin
    DosError:=FndFirst(DestPath+Source.GetName, faAnyFile-faVolumeID, SearchRec);
    if DosError=0 then
     begin
      {file exists}
      if not ConfirmRewrite then
       begin
        FmConfirm:= TFmConfirm.Create(Self);
        case FmConfirm.Ask('File: '+DestPath+Source.GetName,'already exists','Rewrite?') of
         mrCancel: Cancel:=true;
         mrAll:    ConfirmRewrite:=true;
         mrNo:     Skip:=true;
        end;
      FmConfirm.Free;
       end;
      if ((SearchRec.Attr and faHidden)>0) or ((SearchRec.Attr and faSysFile)>0) and not ConfirmHS then
       begin
        {existujici soubor je system nebo hidden}
        FmConfirm:= TFmConfirm.Create(Self);
        case FmConfirm.Ask('File: '+DestPath+Source.GetName,'is SYSTEM or HIDDEN','Rewrite?') of
         mrCancel: Cancel:=true;
         mrAll:    ConfirmHS:=true;
         mrNo:     Skip:=true;
        end;
        FmConfirm.Free;
       end
      else
       if ((SearchRec.Attr and faReadOnly)>0) and not ConfirmR then
        begin
         {existujici soubor je read only}
         FmConfirm:= TFmConfirm.Create(Self);
         case FmConfirm.Ask('File: '+DestPath+Source.GetName,'is READ ONLY','Rewrite?') of
          mrCancel: Cancel:=true;
          mrAll:    ConfirmR:=true;
          mrNo:     Skip:=true;
         end;
         FmConfirm.Free;
        end;
     end;
    Success:=false;
    while not (Skip or Cancel or Success) do
     try
      if ((SearchRec.Attr and 7)>0) and (DosError=0) then
       if not FileSetAttrDate(DestPath+Source.GetName,faArchive,0) then
        raise EInOutError.Create('Cannot change atrributes');
      FOpen(ToF,DestPath+Source.GetName,fmWrite);
      Success:=true;
     except
      FmConfirm:= TFmConfirm.Create(Self);
      case FmConfirm.Ask1('File: '+DestPath+Source.GetName,'is ACCESS DENIED','Retry?') of
       mrCancel: Cancel:=true;
       mrNo:     Skip:=true;
      end;
      FmConfirm.Free;
     end;
   end;
  {block read}
  if not (Skip or Cancel) then
   begin
    if not PfPf then
     begin
      GetMem(Buf, CopyBufSize);
      try
      repeat
       BlckRead(FromF, Buf^, CopyBufSize, NumRead);
       if (NumRead=0) and (Byte1Count<Source.Size) then
        raise EInOutError.Create('Cannot read source file');
       BlckWrite(ToF, Buf^, NumRead, NumWritten);
       if (NumRead>0) and (NumRead<>NumWritten) then
        raise EInOutError.Create('Disk full');
       inc(ByteCount,NumRead);
       inc(Byte1Count,NumRead);
       try
        MyReal:=Gauge1.MaxValue * (Byte1Count / Bytes1Count);
        Gauge1.Progress:=Trunc(MyReal);
        MyReal:=Gauge2.MaxValue * (ByteCount / BytesCount);
        Gauge2.Progress:=Trunc(MyReal);
       except
        {deleni nulou}
       end;
       Label5.Caption:=IntToStr(ByteCount div 1024)+'/'+IntToStr(BytesCount div 1024)+' kB';
       Application.ProcessMessages;
       if Canceled then raise EInOutError.Create('User break.');
       Update;
      until (NumRead < CopyBufSize);
      except
       {smazat soubor pokud nebyl zkopirovan}
       {message a konec}
       Cancel:=true;
      end;
      FreeMem(Buf, CopyBufSize);
     end
    else
      begin
       {copy internal}
       PfPath:=SourcePath+Source.GetName;
       PfPath[1]:=Drives[UpCase(SourcePath[1])].PfDrive;
       if PFForm.PFCopyInternal(PfPath)<0 then
        begin
         application.messagebox('copy internal error','error',mb_ok);
        end
       else
        begin
         inc(ByteCount,Source.Size);
         inc(Byte1Count,Source.Size);
         try
          MyReal:=Gauge1.MaxValue * (Byte1Count / Bytes1Count);
          Gauge1.Progress:=Trunc(MyReal);
          MyReal:=Gauge2.MaxValue * (ByteCount / BytesCount);
          Gauge2.Progress:=Trunc(MyReal);
         except
          {deleni nulou}
         end;
         Label5.Caption:=IntToStr(ByteCount div 1024)+'/'+IntToStr(BytesCount div 1024)+' kB';
         Update;
        end;
      end;
    try
     FClose(ToF);
     FileSetAttrDate(DestPath+Source.GetName, Source.Attr, Source.Time);
    finally
     try
      if not PfPf then
       FClose(FromF);
     except
     end;
    end;
   end;
  if Cancel then Result:=-1
            else Result:=0;
end;


function TFmBatchProcess.DeleteFile(Source: TFileRec; SourcePath: string):integer;
 var Skip, Cancel: boolean;
 begin
  inc(FileCount);
  Label2.Caption:='File:'+SourcePath+Source.GetName;
  Label4.Caption:=IntToStr(FileCount)+'/'+IntToStr(FilesCount);
  Gauge1.Progress:=Gauge1.MaxValue * FileCount div FilesCount;
  Update;
  Skip:=false;
  Cancel:=false;
  if ((Source.Attr and faSysFile)>0) or ((Source.Attr and faHidden)>0) and not ConfirmHS then
   begin
    FmConfirm:= TFmConfirm.Create(Self);
    case FmConfirm.Ask('File: '+SourcePath+Source.GetName,'is SYSTEM or HIDDEN','Delete anyway?') of
     mrCancel: Cancel:=true;
     mrAll:    ConfirmHS:=true;
     mrNo:     Skip:=true;
    end;
    FmConfirm.Free;
   end
  else
  if ((Source.Attr and faReadOnly)>0) and not ConfirmR then
   begin
    FmConfirm:= TFmConfirm.Create(Self);
    case FmConfirm.Ask('File: '+SourcePath+Source.GetName,'is READ ONLY','Delete anyway?') of
     mrCancel: Cancel:=true;
     mrAll:    ConfirmR:=true;
     mrNo:     Skip:=true;
    end;
    FmConfirm.Free;
   end;
  while not (Skip or Cancel) do
    try
     if (Source.Attr and 7)>0 then
      if not FileSetAttrDate(SourcePath+Source.GetName,Source.Attr and $F8,0) then
       raise EInOutError.Create('Cannot change atrributes');
     if not DelFile(SourcePath+Source.GetName) then
      raise EInOutError.Create('Access dennied');
     Skip:=true;
    except
     FmConfirm:= TFmConfirm.Create(Self);
     case FmConfirm.Ask1('File: '+SourcePath+Source.GetName,'is ACCESS DENIED','Retry?') of
      mrCancel: Cancel:=true;
      mrNo:     Skip:=true;
     end;
     FmConfirm.Free;
    end;
  if Cancel then Result:=-1
            else Result:=0;
 end;

function TFmBatchProcess.SetAttribFile(Source: TFileRec; SourcePath: string;
                                        AttrSet,AttrClear:byte; Time: longint):integer;
 var lAttr: word;
     Pf: boolean;
 begin
  if (Source.Attr and faDirectory)=0 then
   inc(FileCount);
  Label2.Caption:='File:'+SourcePath+Source.GetName;
  Label4.Caption:=IntToStr(FileCount)+'/'+IntToStr(FilesCount);
  if FilesCount>0 then
   Gauge1.Progress:=Gauge1.MaxValue * FileCount div FilesCount;
  Update;
  lAttr:=Source.Attr and (faArchive+faReadOnly+faSysFile+faHidden);
  lAttr:=lAttr or AttrSet;
  lAttr:=lAttr and AttrClear;
  Pf:=Drives[UpCase(SourcePath[1])].DriveType=dtPortfolio;
  if (Source.Attr and faDirectory)>0 then
   begin
    if not Pf then
     if FileSetAttrDate(SourcePath+Source.GetName,lAttr,0) then
      Result:=0
     else
      Result:=-1;
   end
  else
   if FileSetAttrDate(SourcePath+Source.GetName,lAttr,Time) then
    Result:=0
   else
    Result:=-1;
 end;

function TFmBatchProcess.MakeDir(Source: TFileRec; SourcePath: string): integer;
 var Skip, Cancel: boolean;
     DosError: integer;
     SearchRec: TSearchRec;
 begin
  Label2.Caption:='Create directory:'+SourcePath+Source.GetName;
  Label3.Caption:='';
  Update;
  Skip:=false;
  Cancel:=false;
  while not (Skip or Cancel) do
   try
    MakeDirectory(SourcePath+Source.GetName);
    Skip:=true;
   except
    DosError:=FndFirst(SourcePath+Source.GetName, Source.Attr, SearchRec);
    if DosError=0 then Skip:=true
    else
     begin
      FmConfirm:= TFmConfirm.Create(Self);
      case FmConfirm.Ask1('Directory: '+SourcePath+Source.GetName,'error ACCESS DENIED','Retry?') of
       mrCancel: Cancel:=true;
       mrNo:     Cancel:=true;
      end;
      FmConfirm.Free;
     end;
   end;
  if Cancel then Result:=-1
            else Result:=0;
 end;

 function TFmBatchProcess.RemoveDir(Source: TFileRec; SourcePath: string): integer;
 var Skip, Cancel: boolean;
 begin
  Label2.Caption:='Remove directory:'+SourcePath+Source.GetName;
  Label3.Caption:='';
  Update;
  Skip:=false;
  Cancel:=false;
  if ((Source.Attr and faSysFile)>0) or ((Source.Attr and faHidden)>0) and not ConfirmHS then
   begin
    FmConfirm:= TFmConfirm.Create(Self);
    case FmConfirm.Ask('Directory: '+SourcePath+Source.GetName,'is SYSTEM or HIDDEN','Delete anyway?') of
     mrCancel: Cancel:=true;
     mrAll:    ConfirmHS:=true;
     mrNo:     Skip:=true;
    end;
    FmConfirm.Free;
   end
  else
  if ((Source.Attr and faReadOnly)>0) and not ConfirmR then
   begin
    FmConfirm:= TFmConfirm.Create(Self);
    case FmConfirm.Ask('Directory: '+SourcePath+Source.GetName,'is READ ONLY','Delete anyway?') of
     mrCancel: Cancel:=true;
     mrAll:    ConfirmR:=true;
     mrNo:     Skip:=true;
    end;
    FmConfirm.Free;
   end;
  while not (Skip or Cancel) do
    try
     RmvDir(SourcePath+Source.GetName);
     Skip:=true;
    except
     FmConfirm:= TFmConfirm.Create(Self);
     case FmConfirm.Ask1('Directory: '+SourcePath+Source.GetName,'is ACCESS DENIED','Retry?') of
      mrCancel: Cancel:=true;
      mrNo:     Skip:=true;
     end;
     FmConfirm.Free;
    end;
  if Cancel then Result:=-1
            else Result:=0;
 end;

function TFmBatchProcess.MoveFile(Source: TFileRec; SourcePath, DestPath: string): integer;
 begin
  Label2.Caption:='From:'+SourcePath+Source.GetName;
  Label3.Caption:='To:'+DestPath+Source.GetName;
  inc(FileCount);
  if not RnmFile(SourcePath+Source.GetName,DestPath+Source.GetName) then
   begin
    CopyFile(Source,SourcePath,DestPath);
    DeleteFile(Source,SourcePath);
   end;
 end;

procedure TFmBatchProcess.CancelButtonClick(Sender: TObject);
begin
 Canceled:=true;
end;

procedure TFmBatchProcess.FormCreate(Sender: TObject);
begin
 Left:=(Owner as TForm).Left+((Owner as TForm).Width-Width) div 2;
 Top:=(Owner as TForm).Top+((Owner as TForm).Height-Height) div 2;
end;

end.
