unit Fmoption;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, IniFiles;

type
  TFormOption = class(TForm)
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Button7: TButton;
    Button5: TButton;
    GroupBox2: TGroupBox;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    Edit1: TEdit;
    Label1: TLabel;
    GroupBox3: TGroupBox;
    ComboBox1: TComboBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button7Click(Sender: TObject);
  private
    { Private declarations }
    FTIniFile: TIniFile;
  public
    { Public declarations }
  end;

var
  FormOption: TFormOption;

implementation

{$R *.DFM}

procedure TFormOption.FormCreate(Sender: TObject);
begin
 Left:=(Owner as TForm).Left+((Owner as TForm).Width-Width) div 2;
 Top:=(Owner as TForm).Top+((Owner as TForm).Height-Height) div 2;
 FTIniFile := TIniFile.Create('FTWIN2.INI');
end;

procedure TFormOption.FormDestroy(Sender: TObject);
begin
 FTIniFile.Free;
end;

procedure TFormOption.Button5Click(Sender: TObject);
begin
 {write ini}
  with FTIniFile do
   begin
    if RadioButton1.Checked then
     WriteInteger('OPTIONS', 'Interface', 1)
    else
     WriteInteger('OPTIONS', 'Interface', 2);
    if RadioButton3.Checked then
     begin
      WriteInteger('OPTIONS', 'Port', 1);
      WriteInteger('OPTIONS','Lpt',
                   StrToInt('$'+Copy(Label2.Caption,2,Length(Label2.Caption)-2)));
     end;
    if RadioButton4.Checked then WriteInteger('OPTIONS', 'Port', 2);
    if RadioButton5.Checked then WriteInteger('OPTIONS', 'Port', 3);
    if RadioButton6.Checked then WriteInteger('OPTIONS', 'Port', 4);
    WriteString('OPTIONS', 'UserPort', Edit1.Text);
    WriteInteger('OPTIONS', 'Com', ComboBox1.ItemIndex);
   end;
end;

procedure TFormOption.FormShow(Sender: TObject);
var PomInt: integer;
    Port: word;
    Seg0000: word;
begin
 {read ini}
  with FTIniFile do
   begin
    PomInt:=ReadInteger('OPTIONS', 'Interface', 1);
    if PomInt=1 then RadioButton1.Checked:=true
                else RadioButton2.Checked:=true;
    PomInt:=ReadInteger('OPTIONS', 'Port', 1);
    case PomInt of
     1: RadioButton3.Checked:=true;
     2: RadioButton4.Checked:=true;
     3: RadioButton5.Checked:=true;
     4: RadioButton6.Checked:=true;
    end;
    Edit1.Text:= ReadString('OPTIONS', 'UserPort', '');
    ComboBox1.ItemIndex:=ReadInteger('OPTIONS', 'Com', 0);

    asm
     mov ax,2
     mov bx,$0000
     int $31
     mov Seg0000,ax
    end;
    Port:=MemW[Seg0000:$0408];
    if Port=0 then
     begin
      Label2.Caption:='';
      RadioButton3.Enabled:=false;
     end
    else
     Label2.Caption:='('+IntToHex(Port,4)+')';
    Port:=MemW[Seg0000:$040A];
    if Port=0 then
     begin
      Label3.Caption:='';
      RadioButton4.Enabled:=false;
     end
    else
     Label3.Caption:='('+IntToHex(Port,4)+')';
    Port:=MemW[Seg0000:$040C];
    if Port=0 then
     begin
      Label4.Caption:='';
      RadioButton5.Enabled:=false;
     end
    else
     Label4.Caption:='('+IntToHex(Port,4)+')';
   end;
end;

procedure TFormOption.FormClose(Sender: TObject; var Action: TCloseAction);
var i:word;
begin
 try
  if Edit1.Text<>'' then
   i:=StrToInt(Edit1.Text);
 except
  Application.MessageBox('Invalid port number.','Atari Portfolio Manager',
                         mb_ok+mb_iconstop);
  Action:=caNone;
 end;
end;

procedure TFormOption.Button7Click(Sender: TObject);
begin
 Edit1.Text:='';
end;

end.
