{last modified 12.5.2014}
{buglist
}
{to do
 -connect (revert strobe)
 -rebuild to component
 -port to 32bit is under construction
}
unit Pf;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Gauges, Buttons;

const pfCMD_nocommand    =0;
      pfCMD_setdatetime  =1;
      pfCMD_findfirst    =2;
      pfCMD_findnext     =3;
      pfCMD_openfile     =4;
      pfCMD_copyinternal =5;
      pfCMD_closefile    =6;
      pfCMD_blockread    =7;
      pfCMD_blockwrite   =8;
      pfCMD_setattr      =9;
      pfCMD_delete       =10;
      pfCMD_rmdir        =11;
      pfCMD_rename       =12;
      pfCMD_makedir      =13;
      pfCMD_getdrives    =14;
      pfCMD_getdir       =15;
      pfCMD_setvolumeid  =16;
      pfCMD_getdisksizes =17;
      pfCMD_exec         =18;

      pfMSG_ok           =100;
      pfMSG_error        =101;

      pfTimeOut = 5000;

type

  EPfException=class(Exception)
   ErrorCode:integer;
   constructor CreatePfError(aMsg: string; aErrorCode: integer);
  public
   function GetErrorCode: integer;
  end;

  TPFBuffer=array[0..2047] of byte;
  PPFBuffer=^TPFBuffer;
  TPFCommand=record
    Command:byte;
    Len:word;
    Buff:PPFBuffer;
   end;
  PPFCommand=^TPFCommand;

  TPFResult=(pfNone,pfSuccess,pfError,pfCancel);
  TPFInterface=(ifNone,ifParalell,ifSerial);

  TPFForm = class(TForm)
    GaugeOut: TGauge;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    GaugeIn: TGauge;
    CancelButton: TBitBtn;
    Timer1: TTimer;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    function IsBusySet:boolean;
    function ReceiveNibble(var x:byte):boolean;
    function ReceiveByteP(var x:byte):boolean;
    function TransmitByteP(x:byte):boolean;
    function ReceiveByteS(var x:byte):boolean;
    function TransmitByteS(x:byte):boolean;
    function ReceiveByte(var x:byte):boolean;
    function TransmitByte(x:byte):boolean;
    function TransmitCommand:boolean;
    function ReceiveMessage:boolean;
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    CMD: PPFCommand;
    MSG: PPFCommand;
    PFResult: TPFResult;
    BufferIndex: integer;
    StopFlag: boolean;
   public
    { Public declarations }
    PFInterFace:TPFInterface;
    PFComPort: string;
    PFLptPort: word;
    function PFFindFirst(const Path: string; Attr: Word; var SearchRec: TSearchRec): Integer;
    function PFFindNext(var SearchRec: TSearchRec): Integer;
    function PFGetDrives(var Drives: string): Integer;
    function PFSetVolumeID(NewLabel:string; Drive:char): Integer;
    function PFFindFirstBuf(Path:string;Attr: Word; var SearchRec: TSearchRec): Integer;
    function PFFindNextBuf(var SearchRec: TSearchRec): Integer;
    function PFMkDir(PFPath:string):integer;
    function PFRmDir(PFPath:string):integer;
    function PFSetSysDateTime(DateTime: TDateTime):integer;
    function PFGetDiskSizes(Drive: byte;var DS,DF: longint):integer;
    function PFExec(Path:string):integer;
    function PFOpenFile(FileName: string; Mode: byte):integer;
    function PFCloseFile:integer;
    function PFDeleteFile(FileName: string):integer;
    function PFBlockRead(var Buf;Count: word; var Res: word):integer;
    function PFBlockWrite(var Buf;Count: word; var Res: word):integer;
    function PFRename(OldName,NewName:string):integer;
    function PFSetAttr(Attr: word; Time: longint):integer;
    function PFCopyInternal(SourceFile:string):integer;
  end;

var
  PFForm: TPFForm;

implementation

var
  MyCid: integer;

{$R *.DFM}

constructor EPfException.CreatePfError(aMsg: string; aErrorCode: integer);
 begin
  inherited Create(aMsg);
  ErrorCode:=aErrorCode;
 end;

function EPfException.GetErrorCode: integer;
 begin
  Result:=ErrorCode;
 end;

function StarToQuestionMark(Path:string):string;
 var lPath:string;
     i:byte;
 begin
   lPath:='';
   for i:=1 to Length(Path) do
    if Path[i]='*' then lPath:=lPath+'????????'
                   else lPath:=lPath+Path[i];
   StarToQuestionMark:=lPath;
 end;

function TPFForm.IsBusySet:boolean;
 var flag:byte;
     PortBase:word;
 begin
  PortBase:=PFLptPort;
  asm
   mov al,0
   mov flag,al
   mov dx,PortBase
   add dx,1
   in  al,dx
   cmp al,$80
   jnb @l1
   inc flag
   @l1:
  end;
   if flag>0 then IsBusySet:=true
   else IsBusySet:=false;
 end;

function TPFForm.ReceiveNibble(var x:byte):boolean;
 var lx:byte;
     portTimeOut: boolean;
     portTick: longint;
     PortBase:word;
 begin
  {wait for busy set}
  portTimeOut:=false;
  portTick:=GetTickCount;
  PortBase:=PFLptPort;
  repeat
   Application.ProcessMessages;
   if (GetTickCount-portTick)>pfTimeOut then portTimeOut:=true;
  until IsBusySet or portTimeOut or StopFlag;
  if portTimeOut or StopFlag then
   begin
    ReceiveNibble:=false;
    Exit;
   end;
  {set strobe}
  asm
   mov dx,PortBase
   add dx,2
   mov al,0
   out dx,al
   mov dx,PortBase
   add dx,1
   in  al,dx
   shr al,3
   and al,$F
   mov lx,al
  end;
  {wait for busy clear}
  portTick:=GetTickCount;
  repeat
   Application.ProcessMessages;
   if (GetTickCount-portTick)>pfTimeOut then portTimeOut:=true;
  until not IsBusySet or portTimeOut or StopFlag;
  {clear strobe}
  asm
   mov dx,PortBase
   add dx,2
   in  al,dx
   or  al,1
   out dx,al
  end;
  if portTimeOut or StopFlag then
   begin
    ReceiveNibble:=false;
   end
  else
   begin
    x:=lx;
    ReceiveNibble:=true;
   end;
 end;

function TPFForm.ReceiveByteP(var x:byte):boolean;
 var LowNibble,HighNibble:byte;
 begin
   if not ReceiveNibble(LowNibble) then
    begin
     ReceiveByteP:=false;
     Exit;
    end;
   if not ReceiveNibble(HighNibble) then
    begin
     ReceiveByteP:=false;
     Exit;
    end;
   x:=16*HighNibble+LowNibble;
   ReceiveByteP:=true;
 end;

function TPFForm.TransmitByteP(x:byte):boolean;
 var flag:byte;
     portTimeOut: boolean;
     portTick: longint;
     PortBase: word;
 begin
  PortBase:=PFLptPort;
  asm
   mov al,x
   mov dx,PortBase
   out dx,al                       {send data}
   mov dx,PortBase
   add dx,2
   in  al,dx
   and al,$0E                      {set strobe=1}
   mov al,0
   out dx,al
  end;
  portTimeOut:=false;
  portTick:=GetTickCount;
  repeat
   Application.ProcessMessages;
   if (GetTickCount-portTick)>pfTimeOut then portTimeOut:=true;
  until IsBusySet or portTimeOut or StopFlag;
  asm
   mov dx,PortBase
   add dx,2
   in  al,dx
   or  al,1                       {set strobe=0}
   out dx,al
  end;
  if portTimeOut or StopFlag then
    begin
     TransmitByteP:=false;
     Exit;
    end
  else
   begin
    portTick:=GetTickCount;
    repeat
     Application.ProcessMessages;
     if (GetTickCount-portTick)>pfTimeOut then portTimeOut:=true;
    until not IsBusySet or portTimeOut or StopFlag;
    TransmitByteP:=not (portTimeOut or StopFlag);
   end;
 end;

function TPFForm.TransmitByteS(x:byte):boolean;
 var s:PChar;
 begin
  Application.ProcessMessages;
  if StopFlag then TransmitByteS:=false
  else
   begin
    s:=StrAlloc(2);
    StrPCopy(s, chr(x));
    WriteComm(MyCid,s,1);
    StrDispose(s);
    TransmitByteS:=true;
   end;
 end;

 function TPFForm.ReceiveByteS(var x:byte):boolean;
 var S: PChar;
     PomStr: string;
     Done: boolean;
 begin
  x:=0;
  S:=StrAlloc(2);
  Done:=false;
  repeat
   if ReadComm(MyCid,S, 1)=1 then
    begin
     PomStr:=StrPas(S);
     if PomStr='' then x:=0
                  else x:=Ord(PomStr[1]);
     Done:=true;
    end
   else
    begin
     Application.ProcessMessages;
     Done:=StopFlag;
    end;
  until Done;
  StrDispose(S);
  ReceiveByteS:=not StopFlag;
 end;

function TPFForm.ReceiveByte(var x:byte):boolean;
 begin
  if PFInterface=ifParalell then ReceiveByte:=ReceiveByteP(x)
  else
   if PFInterface=ifSerial then ReceiveByte:=ReceiveByteS(x)
   else ReceiveByte:=false;
 end;

 function TPFForm.TransmitByte(x:byte):boolean;
 begin
  if PFInterface=ifParalell then TransmitByte:=TransmitByteP(x)
  else
   if PFInterface=ifSerial then TransmitByte:=TransmitByteS(x)
   else TransmitByte:=false;
 end;

function TPFForm.TransmitCommand:boolean;
 var i:word;
 begin
  with CMD^ do
   begin
    GaugeOut.MaxValue:=Len+3;
    if not TransmitByte(Command) then
     begin
      TransmitCommand:=false;
      Exit;
     end;
    GaugeOut.Progress:=1;
    if not TransmitByte(Lo(Len)) then
     begin
      TransmitCommand:=false;
      Exit;
     end;
    GaugeOut.Progress:=2;
    if not TransmitByte(Hi(Len)) then
     begin
      TransmitCommand:=false;
      Exit;
     end;
    GaugeOut.Progress:=3;
    for i:=1 to Len do
     if not TransmitByte(Buff^[i-1]) then
      begin
       TransmitCommand:=false;
       Exit;
      end
     else
      GaugeOut.Progress:=GaugeOut.Progress+1;
    TransmitCommand:=true;
   end;
 end;

 function TPFForm.ReceiveMessage:boolean;
 var i:word;
     LoLength,HiLength:byte;
 begin
  with MSG^ do
   begin
    if not ReceiveByte(Command) then
     begin
      ReceiveMessage:=false;
      Exit;
     end;
    if not ReceiveByte(LoLength) then
     begin
      ReceiveMessage:=false;
      Exit;
     end;
    if not ReceiveByte(HiLength) then
     begin
      ReceiveMessage:=false;
      Exit;
     end;
    Len:=256*HiLength+LoLength;
    GaugeIn.MaxValue:=Len+3;
    GaugeIn.Progress:=3;
    for i:=1 to Len do
     if not ReceiveByte(Buff^[i-1]) then
      begin
       ReceiveMessage:=false;
       Exit;
      end
     else
      GaugeIn.Progress:=GaugeIn.Progress+1;
    ReceiveMessage:=true;
   end;
 end;

function TPFForm.PFFindFirst(const Path: string; Attr: Word; var SearchRec: TSearchRec): Integer;
 var i:word;
 begin
  with CMD^ do
   begin
    Command:=pfCMD_findfirst;
    Buff^[0]:=Length(Path);
    for i:=1 to Length(Path) do
     Buff^[i]:=ord(Path[i]);
    Buff^[i+1]:=Lo(Attr);
    Buff^[i+2]:=Hi(Attr);
    Len:=Length(Path)+3;
   end;
  ShowModal;
  if PFResult=pfSuccess then
   begin
    with MSG^ do
     begin
      case Command of
       pfMSG_ok   :
        begin
         Move(Buff^,SearchRec,SizeOf(SearchRec));
         PFFindFirst:=0;
        end;
       pfMSG_error:
        begin
         PFFindFirst:=-1;
        end;
      end;
     end;
   end
  else
   PFFindFirst:=-1;
 end;

function TPFForm.PFFindNext(var SearchRec: TSearchRec): Integer;
 begin
  with CMD^ do
   begin
    Command:=pfCMD_findnext;
    Len:=SizeOf(SearchRec);
    Move(SearchRec,Buff^,SizeOf(SearchRec));
   end;
  ShowModal;
  if PFResult=pfSuccess then
   begin
    with MSG^ do
     begin
      case Command of
       pfMSG_ok   :
        begin
         Move(Buff^,SearchRec,SizeOf(SearchRec));
         PFFindNext:=0;
        end;
       pfMSG_error:
        begin
         PFFindNext:=-1;
        end;
      end;
     end;
   end
  else
   PFFindNext:=-1;
 end;

function TPFForm.PFGetDrives(var Drives: string): Integer;
 var i:byte;
 begin
  with CMD^ do
   begin
    Command:=pfCMD_getdrives;
    Len:=0;
   end;
  ShowModal;
  if PFResult=pfSuccess then
   begin
    with MSG^ do
     begin
      case Command of
       pfMSG_ok   :
        begin
         Drives:='';
         for i:=1 to Len do
          if Buff^[i-1]<>ord('B') then
           Drives:=Drives+chr(Buff^[i-1]);
         PFGetDrives:=0;
        end;
       pfMSG_error:
        begin
         raise EPfException.CreatePfError('Atari Connect Error.',Buff^[0]);
         PFGetDrives:=-1;
        end;
      end;
     end;
   end
  else
   begin
    raise EPfException.CreatePfError('Atari Connect Error.',ord(PFResult));
    PFGetDrives:=-1;
   end;
 end;

function TPFForm.PFSetVolumeID(NewLabel:string; Drive:char): Integer;
 var i:byte;
 begin
  with CMD^ do
   begin
    Command:=pfCMD_setvolumeid;
    Buff^[0]:=ord(UpCase(Drive))-ord('A')+1;
    for i:=1 to 11 do
     if i>Length(NewLabel) then Buff^[i]:=32
                           else Buff^[i]:=ord(NewLabel[i]);
    Len:=12;
   end;
  ShowModal;
  if PFResult=pfSuccess then
   begin
    with MSG^ do
     begin
      case Command of
       pfMSG_ok   : PFSetVolumeID:=0;
       pfMSG_error: PFSetVolumeID:=-1;
      end;
     end;
   end
  else
   PFSetVolumeID:=-1;
 end;

function TPFForm.PFFindFirstBuf(Path:string;Attr: Word; var SearchRec: TSearchRec): Integer;
 var i:byte;
     PFPath:string;

 begin
  with CMD^ do
   begin
    PFPath:=StarToQuestionMark(Path);
    Command:=pfCMD_getdir;
    Buff^[0]:=Length(PFPath);
    for i:=1 to Length(PFPath) do
     Buff^[i]:=ord(PFPath[i]);
    Buff^[i+1]:=Lo(Attr);
    Buff^[i+2]:=Hi(Attr);
    Len:=Length(PFPath)+3;
   end;
  ShowModal;
  if PFResult=pfSuccess then
    with MSG^ do
     case Command of
      pfMSG_ok   :
       begin
        Result:=-1;
        if Len>10 then
         if Len>=(10+Buff^[9]) then
          with SearchRec do
           begin
            Attr:=Buff^[0];
            Move(Buff^[1],Time,SizeOf(Time));
            Move(Buff^[5],Size,SizeOf(Size));
            Move(Buff^[9],Name,Buff^[9]+1);
            BufferIndex:=10+Buff^[9];
            Result:=0;
           end;
       end;
      pfMSG_error: Result:=-1;
     end
  else
   Result:=-1;
 end;

function TPFForm.PFFindNextBuf(var SearchRec: TSearchRec): Integer;
 begin
  Result:=-1;
  with MSG^ do
   if (Len-BufferIndex)>10 then
    if (Len-BufferIndex)>=(10+Buff^[9+BufferIndex]) then
     with SearchRec do
      begin
       Attr:=Buff^[BufferIndex];
       Move(Buff^[BufferIndex+1],Time,SizeOf(Time));
       Move(Buff^[BufferIndex+5],Size,SizeOf(Size));
       Move(Buff^[BufferIndex+9],Name,Buff^[BufferIndex+9]+1);
       BufferIndex:=BufferIndex+10+Buff^[BufferIndex+9];
       Result:=0;
      end;
 end;

function TPFForm.PFMkDir(PFPath:string):integer;
 begin
  with CMD^ do
   begin
    Command:=pfCMD_makedir;
    Move(PFPath,Buff^[0],ord(PFPath[0])+1);
    Len:=Length(PFPath)+1;
   end;
  ShowModal;
  if PFResult=pfSuccess then
   begin
    with MSG^ do
     begin
      case Command of
       pfMSG_ok   : Result:=0;
       pfMSG_error:
        begin
         raise EPfException.CreatePfError('Atari Connect Error.',Buff^[0]);
         Result:=-1;
        end;
      end;
     end;
   end
  else
   begin
    raise EPfException.CreatePfError('Atari Connect Error.',ord(PFResult));
    Result:=-1;
   end;
 end;

 function TPFForm.PFRmDir(PFPath:string):integer;
 begin
  with CMD^ do
   begin
    Command:=pfCMD_rmdir;
    Move(PFPath,Buff^[0],ord(PFPath[0])+1);
    Len:=Length(PFPath)+1;
   end;
  ShowModal;
  if PFResult=pfSuccess then
   begin
    with MSG^ do
     begin
      case Command of
       pfMSG_ok   : Result:=0;
       pfMSG_error: Result:=-1;
      end;
     end;
   end
  else
   Result:=-1;
 end;

function TPFForm.PFSetSysDateTime(DateTime: TDateTime):integer;
 var Year,Month,Day,Hour,Min,Sec,MSec: word;
 begin
  with CMD^ do
   begin
    Command:=pfCMD_setdatetime;
    Len:=7;
    DecodeTime(DateTime, Hour, Min, Sec, MSec);
    DecodeDate(DateTime, Year, Month, Day);
    Buff^[0]:=Lo(Year);
    Buff^[1]:=Hi(Year);
    Buff^[2]:=Lo(Month);
    Buff^[3]:=Lo(Day);
    Buff^[4]:=Lo(Hour);
    Buff^[5]:=Lo(Min);
    Buff^[6]:=Lo(Sec);
   end;
  ShowModal;
  if PFResult=pfSuccess then
   begin
    with MSG^ do
     begin
      case Command of
       pfMSG_ok   : Result:=0;
       pfMSG_error: Result:=-1;
      end;
     end;
   end
  else
   Result:=-1;
 end;

function TPFForm.PFGetDiskSizes(Drive: byte;var DS,DF: longint):integer;
 var ax,bx,cx,dx:word;
 begin
  with CMD^ do
   begin
    Command:=pfCMD_getdisksizes;
    Len:=1;
    Buff^[0]:=Drive;
    DS:=0;
    DF:=0;
   end;
  ShowModal;
  if PFResult=pfSuccess then
   begin
    with MSG^ do
     begin
      case Command of
       pfMSG_ok   :
        begin
         ax:=Buff^[0]+256*Buff^[1];
         bx:=Buff^[2]+256*Buff^[3];
         cx:=Buff^[4]+256*Buff^[5];
         dx:=Buff^[6]+256*Buff^[7];
         if ax<>$FFFF then
          begin
           DS:=ax*cx*dx;
           DF:=ax*bx*cx;
           Result:=0;
          end
         else
          Result:=-1;
        end;
       pfMSG_error: Result:=-1;
      end;
     end;
   end
  else
   Result:=-1;
 end;

function TPFForm.PFExec(Path:string):integer;
 begin
  with CMD^ do
   begin
    Command:=pfCMD_exec;
    Len:=Length(Path)+1;
    Move(Path,Buff^[0],Len);
   end;
  ShowModal;
  if PFResult=pfSuccess then
   begin
    with MSG^ do
     begin
      case Command of
       pfMSG_ok   : Result:=0;
       pfMSG_error: Result:=-1;
      end;
     end;
   end
  else
   Result:=-1;
 end;

function TPFForm.PFSetAttr(Attr: word; Time: longint):integer;
 begin
  with CMD^ do
   begin
    Command:=pfCMD_setattr;
    Len:=2;
    Move(Attr,Buff^[0],SizeOf(Attr));
    if Time>0 then
     begin
      Move(Time,Buff^[2],SizeOf(Time));
      Inc(Len,SizeOf(Time));
     end;
   end;
  ShowModal;
  if PFResult=pfSuccess then
   begin
    with MSG^ do
     begin
      case Command of
       pfMSG_ok   : Result:=0;
       pfMSG_error: Result:=-1;
      end;
     end;
   end
  else
   Result:=-1;
 end;

function TPFForm.PFOpenFile(FileName:string;Mode: byte):integer;
 begin
  with CMD^ do
   begin
    Command:=pfCMD_openfile;
    Len:=Length(FileName)+2;
    Move(FileName,Buff^[1],Len-1);
    Buff^[0]:=Mode;
   end;
  ShowModal;
  if PFResult=pfSuccess then
   begin
    with MSG^ do
     begin
      case Command of
       pfMSG_ok   : Result:=0;
       pfMSG_error: Result:=-1;
      end;
     end;
   end
  else
   Result:=-1;
 end;

function TPFForm.PFCloseFile:integer;
 begin
  with CMD^ do
   begin
    Command:=pfCMD_closefile;
    Len:=0;
   end;
  ShowModal;
  if PFResult=pfSuccess then
   begin
    with MSG^ do
     begin
      case Command of
       pfMSG_ok   : Result:=0;
       pfMSG_error: Result:=-1;
      end;
     end;
   end
  else
   Result:=-1;
 end;

 function TPFForm.PFDeleteFile(FileName: string):integer;
 begin
  with CMD^ do
   begin
    Command:=pfCMD_delete;
    Len:=Length(FileName)+1;
    Move(FileName,Buff^[0],Len);
   end;
  ShowModal;
  if PFResult=pfSuccess then
   begin
    with MSG^ do
     begin
      case Command of
       pfMSG_ok   : Result:=0;
       pfMSG_error: Result:=-1;
      end;
     end;
   end
  else
   Result:=-1;
 end;

function TPFForm.PFBlockRead(var Buf;Count: word; var Res: word):integer;
 begin
  with CMD^ do
   begin
    Command:=pfCMD_blockread;
    Len:=2;
    Move(Count,Buff^[0],SizeOf(Count));
   end;
  ShowModal;
  if PFResult=pfSuccess then
   begin
    with MSG^ do
     begin
      case Command of
       pfMSG_ok   :
        begin
         Res:=Len;
         Move(Buff^[0],Buf,Len);
         Result:=0;
        end;
       pfMSG_error: Result:=-1;
      end;
     end;
   end
  else
   Result:=-1;
 end;

function TPFForm.PFBlockWrite(var Buf;Count: word; var Res: word):integer;
 begin
  with CMD^ do
   begin
    Command:=pfCMD_blockwrite;
    Len:=Count;
    Move(Buf,Buff^,Count);
   end;
  ShowModal;
  if PFResult=pfSuccess then
   begin
    with MSG^ do
     begin
      case Command of
       pfMSG_ok   :
        begin
         Move(Buff^,Res,2);
         Result:=0;
        end;
       pfMSG_error: Result:=-1;
      end;
     end;
   end
  else
   Result:=-1;
 end;

function TPFForm.PFRename(OldName, NewName: string):integer;
 begin
  with CMD^ do
   begin
    Command:=pfCMD_rename;
    Len:=Length(OldName)+Length(NewName)+2;
    Move(OldName,Buff^[0],Length(OldName)+1);
    Move(NewName,Buff^[Buff^[0]+1],Length(NewName)+1);
   end;
  ShowModal;
  if PFResult=pfSuccess then
   begin
    with MSG^ do
     begin
      case Command of
       pfMSG_ok   : Result:=0;
       pfMSG_error: Result:=-1;
      end;
     end;
   end
  else
   Result:=-1;
 end;

function TPFForm.PFCopyInternal(SourceFile:string):integer;
 begin
  with CMD^ do
   begin
    Command:=pfCMD_copyinternal;
    Len:=Length(SourceFile)+1;
    Move(SourceFile,Buff^[0],Length(SourceFile)+1);
   end;
  ShowModal;
  if PFResult=pfSuccess then
   begin
    with MSG^ do
     begin
      case Command of
       pfMSG_ok   : Result:=0;
       pfMSG_error: Result:=-1;
      end;
     end;
   end
  else
   Result:=-1;
 end;

procedure TPFForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if PFInterface=ifSerial then
  if CloseComm(MyCid)<0 then PFResult:=pfError;
end;

procedure TPFForm.FormCreate(Sender: TObject);
begin
 Top:=Screen.Height-Height-30;
 Left:=Screen.Width-Width;
 CMD:=New(PPFCommand);
 CMD^.Buff:=New(PPFBuffer);
 MSG:=New(PPFCommand);
 MSG^.Buff:=New(PPFBuffer);

 {init settings}
 PFInterface:=ifNone;
 PFComPort:='COM1';
 PFLptPort:=$0378;
end;

procedure TPFForm.FormDestroy(Sender: TObject);
begin
 Dispose(MSG^.Buff);
 Dispose(MSG);
 Dispose(CMD^.Buff);
 Dispose(CMD);
end;

procedure TPFForm.FormShow(Sender: TObject);
var DCB: TDCB;
    lPStr: PChar;
begin
 Update;
 GaugeIn.Progress:=0;
 GaugeOut.Progress:=0;
 PFResult:=pfNone;

 if PFInterface=ifSerial then
  begin
   lPStr:=StrAlloc(Length(PFComPort)+1);
   StrPCopy(lPStr,PFComPort);
   MyCid:=OpenComm(lPStr,1024,1024);
   StrDispose(lPStr);
   if MyCid<0 then
    begin
     PFResult:=pfError;
     Close;
    end;
   if GetCommState(MyCid,DCB)<0 then
    begin
     PFResult:=pfError;
     Close;
    end;
   with DCB do
    begin
     BaudRate:=cbr_9600;
     Parity:=NoParity;
     ByteSize:=8;
     StopBits:=OneStopBit;
     Flags:=dcb_Binary
            +dcb_OutxCtsFlow
            +dcb_RtsFlow;
    end;
   if SetCommState(DCB)<0 then
    begin
     PFResult:=pfError;
     Close;
    end;
   WriteComm(MyCid,'START',5);
  end;

 if not TransmitCommand then
  begin
   PFResult:=pfError;
   Close;
  end;

 Timer1.Enabled:=true;
end;

procedure TPFForm.CancelButtonClick(Sender: TObject);
begin
 PFResult:=pfCancel;
 StopFlag:=true;
end;

procedure TPFForm.Timer1Timer(Sender: TObject);
begin
 if PFInterface=ifParalell then
  begin
   if IsBusySet then
    begin
     Timer1.Enabled:=false;
     if ReceiveMessage then PFResult:=pfSuccess
     else PFResult:=pfError;
     Close;
    end;
   end
 else
  if PFInterface=ifSerial then
   begin
    Timer1.Enabled:=false;
    if ReceiveMessage then PFResult:=pfSuccess
    else PFResult:=pfError;
    Close;
   end
  else
   begin
    PFResult:=pfError;
    Close;
   end;
end;

end.
